package com.liang.dao;

import com.liang.entity.BaseLanguage;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseLanguage)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-15 23:13:15
 */
public interface BaseLanguageDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseLanguage queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param baseLanguage 查询条件
     * @param pageable     分页对象
     * @return 对象列表
     */
    List<BaseLanguage> queryAllByLimit(BaseLanguage baseLanguage, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseLanguage 查询条件
     * @return 总行数
     */
    long count(BaseLanguage baseLanguage);

    /**
     * 新增数据
     *
     * @param baseLanguage 实例对象
     * @return 影响行数
     */
    int insert(BaseLanguage baseLanguage);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseLanguage> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseLanguage> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseLanguage> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseLanguage> entities);

    /**
     * 修改数据
     *
     * @param baseLanguage 实例对象
     * @return 影响行数
     */
    int update(BaseLanguage baseLanguage);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取外语语种列表
     *
     * @return
     */
    List<Map<String, String>> getLanguageList();
}

